static const char *ClassId    = "$Id: DigitalDelayGeneratorClass.cpp,v 1.3 2011-05-01 22:30:28 xavela Exp $";
static const char *CvsPath    = "$Source: /users/chaize/newsvn/cvsroot/Instrumentation/DigitalDelayGenerator/src/DigitalDelayGeneratorClass.cpp,v $";
static const char *SvnPath    = "$HeadURL: $";
static const char *RcsId     = "$Header: /users/chaize/newsvn/cvsroot/Instrumentation/DigitalDelayGenerator/src/DigitalDelayGeneratorClass.cpp,v 1.3 2011-05-01 22:30:28 xavela Exp $";
static const char *TagName   = "$Name: not supported by cvs2svn $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        DigitalDelayGeneratorClass.cpp
//
// description : C++ source for the DigitalDelayGeneratorClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the DigitalDelayGenerator once per process.
//
// project :     TANGO Device Server
//
// $Author: xavela $
//
// $Revision: 1.3 $
//
// $Log: not supported by cvs2svn $
// Revision 1.2  2010/03/26 09:20:50  vince_soleil
// "Migration_Tango7_Part2"
//
// Revision 1.1  2009/01/21 13:04:56  stephle
// initial import
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <DigitalDelayGenerator.h>
#include <DigitalDelayGeneratorClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create DigitalDelayGeneratorClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_DigitalDelayGenerator_class(const char *name) {
		return DigitalDelayGenerator_ns::DigitalDelayGeneratorClass::init(name);
	}
}


namespace DigitalDelayGenerator_ns
{
//+----------------------------------------------------------------------------
//
// method : 		RecallModuleConfigurationClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *RecallModuleConfigurationClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "RecallModuleConfigurationClass::execute(): arrived" << endl;

	((static_cast<DigitalDelayGenerator *>(device))->recall_module_configuration());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SaveModuleConfigurationClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SaveModuleConfigurationClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SaveModuleConfigurationClass::execute(): arrived" << endl;

	((static_cast<DigitalDelayGenerator *>(device))->save_module_configuration());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ResetShotsCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ResetShotsCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ResetShotsCmd::execute(): arrived" << endl;

	((static_cast<DigitalDelayGenerator *>(device))->reset_shots());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		HardwareResetCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *HardwareResetCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "HardwareResetCmd::execute(): arrived" << endl;

	((static_cast<DigitalDelayGenerator *>(device))->hardware_reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ClearErrorsClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ClearErrorsClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ClearErrorsClass::execute(): arrived" << endl;

	((static_cast<DigitalDelayGenerator *>(device))->clear_errors());
	return new CORBA::Any();
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
DigitalDelayGeneratorClass *DigitalDelayGeneratorClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::DigitalDelayGeneratorClass(string &s)
// 
// description : 	constructor for the DigitalDelayGeneratorClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
DigitalDelayGeneratorClass::DigitalDelayGeneratorClass(string &s):DeviceClass(s)
{

	cout2 << "Entering DigitalDelayGeneratorClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving DigitalDelayGeneratorClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::~DigitalDelayGeneratorClass()
// 
// description : 	destructor for the DigitalDelayGeneratorClass
//
//-----------------------------------------------------------------------------
DigitalDelayGeneratorClass::~DigitalDelayGeneratorClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
DigitalDelayGeneratorClass *DigitalDelayGeneratorClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new DigitalDelayGeneratorClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

DigitalDelayGeneratorClass *DigitalDelayGeneratorClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::command_factory()
{
	command_list.push_back(new HardwareResetCmd("HardwareReset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"no argin",
		"no argout",
		Tango::OPERATOR));
	command_list.push_back(new ClearErrorsClass("ClearErrors",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"no argin",
		"no argout",
		Tango::OPERATOR));
	command_list.push_back(new ResetShotsCmd("ResetShots",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"no argin",
		"no argout",
		Tango::EXPERT));
	command_list.push_back(new SaveModuleConfigurationClass("SaveModuleConfiguration",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"no argin",
		"no argout",
		Tango::OPERATOR));
	command_list.push_back(new RecallModuleConfigurationClass("RecallModuleConfiguration",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"no argin",
		"no argout",
		Tango::EXPERT));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum DigitalDelayGeneratorClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum DigitalDelayGeneratorClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum DigitalDelayGeneratorClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new DigitalDelayGenerator(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: DigitalDelayGeneratorClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : shotsCounter
	shotsCounterAttrib	*shots_counter = new shotsCounterAttrib();
	Tango::UserDefaultAttrProp	shots_counter_prop;
	shots_counter_prop.set_label("shots counter");
	shots_counter_prop.set_unit(" ");
	shots_counter_prop.set_standard_unit(" ");
	shots_counter_prop.set_display_unit(" ");
	shots_counter_prop.set_format("%6.0d");
	shots_counter_prop.set_description("Query shot counter");
	shots_counter->set_default_properties(shots_counter_prop);
	att_list.push_back(shots_counter);

	//	Attribute : pulseDelayChannelA
	pulseDelayChannelAAttrib	*pulse_delay_channel_a = new pulseDelayChannelAAttrib();
	Tango::UserDefaultAttrProp	pulse_delay_channel_a_prop;
	pulse_delay_channel_a_prop.set_label("pulse delay channel A");
	pulse_delay_channel_a_prop.set_unit("ns");
	pulse_delay_channel_a_prop.set_standard_unit("ns");
	pulse_delay_channel_a_prop.set_display_unit("ns");
	pulse_delay_channel_a_prop.set_format("%6.2f");
	pulse_delay_channel_a_prop.set_description("Channel A pulse delay (unit : nanosecond).");
	pulse_delay_channel_a->set_default_properties(pulse_delay_channel_a_prop);
	att_list.push_back(pulse_delay_channel_a);

	//	Attribute : pulseWidthChannelA
	pulseWidthChannelAAttrib	*pulse_width_channel_a = new pulseWidthChannelAAttrib();
	Tango::UserDefaultAttrProp	pulse_width_channel_a_prop;
	pulse_width_channel_a_prop.set_label("pulse width channel A");
	pulse_width_channel_a_prop.set_format("%6.2f");
	pulse_width_channel_a_prop.set_description("Channel A pulse width");
	pulse_width_channel_a->set_default_properties(pulse_width_channel_a_prop);
	att_list.push_back(pulse_width_channel_a);

	//	Attribute : activateChannelA
	activateChannelAAttrib	*activate_channel_a = new activateChannelAAttrib();
	Tango::UserDefaultAttrProp	activate_channel_a_prop;
	activate_channel_a_prop.set_label("activate channel A");
	activate_channel_a_prop.set_unit(" ");
	activate_channel_a_prop.set_standard_unit(" ");
	activate_channel_a_prop.set_display_unit(" ");
	activate_channel_a_prop.set_description("TRUE : enable channel A output\nFALSE: disable channel A output");
	activate_channel_a->set_default_properties(activate_channel_a_prop);
	activate_channel_a->set_disp_level(Tango::EXPERT);
	att_list.push_back(activate_channel_a);

	//	Attribute : pulseDelayChannelB
	pulseDelayChannelBAttrib	*pulse_delay_channel_b = new pulseDelayChannelBAttrib();
	Tango::UserDefaultAttrProp	pulse_delay_channel_b_prop;
	pulse_delay_channel_b_prop.set_label("pulse delay channel B");
	pulse_delay_channel_b_prop.set_unit("ns");
	pulse_delay_channel_b_prop.set_standard_unit("ns");
	pulse_delay_channel_b_prop.set_display_unit("ns");
	pulse_delay_channel_b_prop.set_format("%6.2f");
	pulse_delay_channel_b_prop.set_description("Channel B pulse delay (unit : nanosecond).");
	pulse_delay_channel_b->set_default_properties(pulse_delay_channel_b_prop);
	att_list.push_back(pulse_delay_channel_b);

	//	Attribute : pulseWidthChannelB
	pulseWidthChannelBAttrib	*pulse_width_channel_b = new pulseWidthChannelBAttrib();
	Tango::UserDefaultAttrProp	pulse_width_channel_b_prop;
	pulse_width_channel_b_prop.set_label("pulse width channel B");
	pulse_width_channel_b_prop.set_format("%6.2f");
	pulse_width_channel_b_prop.set_description("Channel B pulse width");
	pulse_width_channel_b->set_default_properties(pulse_width_channel_b_prop);
	att_list.push_back(pulse_width_channel_b);

	//	Attribute : activateChannelB
	activateChannelBAttrib	*activate_channel_b = new activateChannelBAttrib();
	Tango::UserDefaultAttrProp	activate_channel_b_prop;
	activate_channel_b_prop.set_label("activate channel B");
	activate_channel_b_prop.set_unit(" ");
	activate_channel_b_prop.set_standard_unit(" ");
	activate_channel_b_prop.set_display_unit(" ");
	activate_channel_b_prop.set_description("TRUE : enable channel B output\nFALSE: disable channel B output");
	activate_channel_b->set_default_properties(activate_channel_b_prop);
	activate_channel_b->set_disp_level(Tango::EXPERT);
	att_list.push_back(activate_channel_b);

	//	Attribute : pulseDelayChannelC
	pulseDelayChannelCAttrib	*pulse_delay_channel_c = new pulseDelayChannelCAttrib();
	Tango::UserDefaultAttrProp	pulse_delay_channel_c_prop;
	pulse_delay_channel_c_prop.set_label("pulse delay channel C");
	pulse_delay_channel_c_prop.set_unit("ns");
	pulse_delay_channel_c_prop.set_standard_unit("ns");
	pulse_delay_channel_c_prop.set_display_unit("ns");
	pulse_delay_channel_c_prop.set_format("%6.2f");
	pulse_delay_channel_c_prop.set_description("Channel C pulse delay (unit : nanosecond).");
	pulse_delay_channel_c->set_default_properties(pulse_delay_channel_c_prop);
	att_list.push_back(pulse_delay_channel_c);

	//	Attribute : pulseWidthChannelC
	pulseWidthChannelCAttrib	*pulse_width_channel_c = new pulseWidthChannelCAttrib();
	Tango::UserDefaultAttrProp	pulse_width_channel_c_prop;
	pulse_width_channel_c_prop.set_label("pulse width channel C");
	pulse_width_channel_c_prop.set_format("%6.2f");
	pulse_width_channel_c_prop.set_description("Channel C pulse width");
	pulse_width_channel_c->set_default_properties(pulse_width_channel_c_prop);
	att_list.push_back(pulse_width_channel_c);

	//	Attribute : activateChannelC
	activateChannelCAttrib	*activate_channel_c = new activateChannelCAttrib();
	Tango::UserDefaultAttrProp	activate_channel_c_prop;
	activate_channel_c_prop.set_label("activate channel C");
	activate_channel_c_prop.set_unit(" ");
	activate_channel_c_prop.set_standard_unit(" ");
	activate_channel_c_prop.set_display_unit(" ");
	activate_channel_c_prop.set_description("TRUE : enable channel C output\nFALSE: disable channel C output");
	activate_channel_c->set_default_properties(activate_channel_c_prop);
	activate_channel_c->set_disp_level(Tango::EXPERT);
	att_list.push_back(activate_channel_c);

	//	Attribute : pulseDelayChannelD
	pulseDelayChannelDAttrib	*pulse_delay_channel_d = new pulseDelayChannelDAttrib();
	Tango::UserDefaultAttrProp	pulse_delay_channel_d_prop;
	pulse_delay_channel_d_prop.set_label("pulse delay channel D");
	pulse_delay_channel_d_prop.set_unit("ns");
	pulse_delay_channel_d_prop.set_standard_unit("ns");
	pulse_delay_channel_d_prop.set_display_unit("ns");
	pulse_delay_channel_d_prop.set_format("%6.2f");
	pulse_delay_channel_d_prop.set_description("Channel D pulse delay (unit : nanosecond).");
	pulse_delay_channel_d->set_default_properties(pulse_delay_channel_d_prop);
	att_list.push_back(pulse_delay_channel_d);

	//	Attribute : pulseWidthChannelD
	pulseWidthChannelDAttrib	*pulse_width_channel_d = new pulseWidthChannelDAttrib();
	Tango::UserDefaultAttrProp	pulse_width_channel_d_prop;
	pulse_width_channel_d_prop.set_label("pulse width channel D");
	pulse_width_channel_d_prop.set_format("%6.2f");
	pulse_width_channel_d_prop.set_description("Channel D pulse width");
	pulse_width_channel_d->set_default_properties(pulse_width_channel_d_prop);
	att_list.push_back(pulse_width_channel_d);

	//	Attribute : activateChannelD
	activateChannelDAttrib	*activate_channel_d = new activateChannelDAttrib();
	Tango::UserDefaultAttrProp	activate_channel_d_prop;
	activate_channel_d_prop.set_label("activate channel D");
	activate_channel_d_prop.set_unit(" ");
	activate_channel_d_prop.set_standard_unit(" ");
	activate_channel_d_prop.set_display_unit(" ");
	activate_channel_d_prop.set_description("TRUE : enable channel D output\nFALSE: disable channel D output");
	activate_channel_d->set_default_properties(activate_channel_d_prop);
	activate_channel_d->set_disp_level(Tango::EXPERT);
	att_list.push_back(activate_channel_d);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	DigitalDelayGeneratorClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "CommunicationProxy";
	prop_desc = "Name of the device which controls the communication link.\nThis module support both RS232 and Ethernet interfaces.";
	prop_def  = "noCommunication/ProxyName/Defined";
	vect_data.clear();
	vect_data.push_back("noCommunication/ProxyName/Defined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		DigitalDelayGeneratorClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void DigitalDelayGeneratorClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Digital Delay Generator T560");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This device controls a T560 Digital Delay Generator :");
	str_desc.push_back("- four TTL-level pulse outputs, each programmable for delay and width up to 10 seconds each, with 10-picosecond resolution.");
	str_desc.push_back("- Programmable-level trigger input with divide/burst features and trigger enable GATE input.");
	str_desc.push_back("Controlled via a RS232 serial interface or a 10/100-mbps Ethernet interface.");
	str_desc.push_back("");
	str_desc.push_back("NOTE :");
	str_desc.push_back("- RS232 config : 38400, 8, N, 1");
	str_desc.push_back("- ETHERNET port : 2000");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename(classname);
	filename += "Class.cpp";
	
	// Create a string with the class ID to
	// get the string into the binary
	string	class_id(ClassId);
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
